package com.cool.store.handler;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.cool.store.config.websocket.WebSocketConfig;
import com.cool.store.utils.RedisUtil;
import com.cool.store.utils.RedisUtilPool;
import com.cool.store.utils.SpringUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import javax.websocket.*;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;
import java.util.concurrent.ConcurrentHashMap;

@Component
@Slf4j
@ServerEndpoint(value="/websocket/{tenantId}",configurator = WebSocketConfig.class)
public class WebSocketServer {

    /**
     * 静态变量，用来记录当前在线连接数。应该把它设计成线程安全的。
     */
    private static int onlineCount = 0;
    /**
     * concurrent包的线程安全Set，用来存放每个客户端对应的WebSocket对象。
     */
    private static final ConcurrentHashMap<String, WebSocketServer> webSocketMap = new ConcurrentHashMap<>();
    /**
     * 与某个客户端的连接会话，需要通过它来给客户端发送数据
     */
    private Session session;
    /**
     * 接收userId
     */
    private String tenantId = "";

    /**
     * 手机号
     */
    private List<String> mobiles;

    private static RedisUtilPool redisUtilPool = SpringUtils.getBean(RedisUtilPool.class);
    /**
     * 连接建立成
     * 功调用的方法
     */
    @OnOpen
    public void onOpen(Session session, @PathParam("tenantId") String tenantId) {
        String mobiles = getHeader(session, "mobiles");
        if(StringUtils.isEmpty(mobiles)){
            return;
        }

        this.mobiles = Arrays.asList(mobiles.split(","));
        this.session = session;
        this.tenantId = tenantId;
        if (webSocketMap.containsKey(tenantId)) {
            webSocketMap.remove(tenantId);
            //加入set中
            webSocketMap.put(tenantId, this);
        } else {
            //加入set中
            webSocketMap.put(tenantId, this);
            //在线数加1
            addOnlineCount();
        }
        for (String mobile : this.mobiles) {
            redisUtilPool.setString(mobile, tenantId, 3600);
        }
        log.info("用户连接:" + tenantId + ",当前在线人数为:" + getOnlineCount());
        sendMessage("连接成功");
    }

    /**
     * 连接关闭
     * 调用的方法
     */
    @OnClose
    public void onClose() {
        if (webSocketMap.containsKey(tenantId)) {
            webSocketMap.get(tenantId).mobiles.forEach(mobile -> redisUtilPool.delKey(mobile));
            webSocketMap.remove(tenantId);
            //从set中删除
            subOnlineCount();
        }
        log.info("用户退出:" + tenantId + ",当前在线人数为:" + getOnlineCount());
    }

    /**
     * 收到客户端消
     * 息后调用的方法
     *
     * @param message 客户端发送过来的消息
     **/
    @OnMessage
    public void onMessage(String message, Session session) {
        log.info("用户消息:" + tenantId + ",报文:" + message);
        //可以群发消息
        //消息保存到数据库、redis
        if (StringUtils.isNotBlank(message)) {
            try {
                //解析发送的报文
                JSONObject jsonObject = JSON.parseObject(message);
                //追加发送人(防止串改)
                jsonObject.put("fromUserId", this.tenantId);
                String toUserId = jsonObject.getString("toUserId");
                //传送给对应toUserId用户的websocket
                if (StringUtils.isNotBlank(toUserId) && webSocketMap.containsKey(toUserId)) {
                    webSocketMap.get(toUserId).sendMessage(message);
                } else {
                    //否则不在这个服务器上，发送到mysql或者redis
                    log.error("请求的userId:" + toUserId + "不在该服务器上");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }


    /**
     * @param session Session
     * @param error   Throwable
     */
    @OnError
    public void onError(Session session, Throwable error) {

        log.error("用户错误:" + this.tenantId + ",原因:" + error.getMessage());
        error.printStackTrace();
    }

    /**
     * 实现服务
     * 器主动推送
     */
    public boolean sendMessage(String message) {
        boolean flag = false;
        try {
            this.session.getBasicRemote().sendText(message);
            flag = true;
        } catch (IOException e) {
            log.error("发送消息失败:" + this.tenantId + ",原因:" + e.getMessage());
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 发送自定
     * 义消息
     **/
    public static boolean sendInfo(String message, String tenantId) {
        boolean flag = false;
        log.info("发送消息到:" + tenantId + "，报文:" + message);
        if (StringUtils.isNotBlank(tenantId) && webSocketMap.containsKey(tenantId)) {
            webSocketMap.get(tenantId).sendMessage(message);
            flag = true;
        } else {
            log.error("用户" + tenantId + ",不在线！");
        }
        return flag;
    }

    /**
     * 获得此时的
     * 在线人数
     *
     * @return int
     */
    public static synchronized int getOnlineCount() {
        return onlineCount;
    }

    /**
     * 在线人
     * 数加1
     */
    public static synchronized void addOnlineCount() {
        WebSocketServer.onlineCount++;
    }

    /**
     * 在线人
     * 数减1
     */
    public static synchronized void subOnlineCount() {
        WebSocketServer.onlineCount--;
    }

    /**
     * 判断用户是否在线
     * @param tenantId
     * @return
     */
    public static boolean isOnline(String tenantId) {
        if(StringUtils.isEmpty(tenantId)) {
            return false;
        }
        return webSocketMap.containsKey(tenantId);
    }

    public static String getHeader(Session session, String headerName) {
        final String header = (String) session.getUserProperties().get(headerName);
        if (StrUtil.isBlank(header)) {
            log.error("获取header失败，不安全的链接，即将关闭");
            try {
                session.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return header;
    }

    public static String getTenantIdByMobile(String mobile){
        String jsonStr = redisUtilPool.getString(mobile);
        if (StringUtils.isNotEmpty(jsonStr)){
            return jsonStr;
        }

        //如果redis中没有，循环webSocketMap，找到对应的tenantId
        for (String key : webSocketMap.keySet()) {
            WebSocketServer webSocketServer = webSocketMap.get(key);
            if (webSocketServer.mobiles.contains(mobile)){
                return webSocketServer.tenantId;
            }
        }

        return null;
    }
}